-- ------------------------------------------------------------------------
-- SETUP
-- ------------------------------------------------------------------------
local font = "Interface\\AddOns\\oUF_Aion\\font\\marigoldwild.ttf"
local fontN = "Interface\\AddOns\\oUF_Aion\\font\\marigoldwild.ttf"
local fontSN = 24 -- font size (names)
local fontS = 16 -- font size (numbers)
local fontF = "THINOUTLINE" --local fontF = nil

local bartex = "Interface\\AddOns\\oUF_Aion\\media\\dAion"
local bufftex = "Interface\\AddOns\\oUF_Aion\\Art\\border"
local borderDebuffHigh = "Interface\\AddOns\\oUF_Aion\\media\\frameborder3large" 

local frameborder = "Interface\\AddOns\\oUF_Aion\\Art\\border"

local scalePlayer = 0.9 -- change player scale
local scalePlayerPet = 0.8 -- change player pet scale
local scaleTarget = 0.8 -- change target, target of target and focus scale
local ScaleParty = 0.8 -- change party scale
local ScalePT = 0.6  -- change party target scale
local ScalePP = 0.6  -- change party pet target scale

local Numberzzz = 1 -- 0 will display 18400k as 18k, 1 = 18.4k, ....

-- show/hide raid frames
local useraid = false
-- show/hide party target frames
local usepartytargets = false
-- show/hide party pet  frames
local usepartypets = false

-- show target's auras on top (true) or bottom (false)
local TargetAurasOnTOP = false

-- NOTE: you should use either one of these, or it might look a "little crazy" ......
-- show/hide AION style Panel 
local useAionPanel = true
-- show/hide viewport
local useviewport = false

-- castbar position
local playerCastBar_x = 0
local playerCastBar_y = -210
local targetCastBar_x = 0
local targetCastBar_y = -60

-- set target castbar scale
local TarCastScale = 1.0

local playerClass = select(2, UnitClass("player"))
-- ------------------------------------------------------------------------
-- change some colors
-- ------------------------------------------------------------------------

local maincolor = {218/255, 194/255, 138/255} -- color of bars, ...
local sndcolor = {218/255, 194/255, 138/255} -- color of text, ...

oUF.colors.happiness = {
	[1] = {182/225, 34/255, 32/255},	-- unhappy
	[2] = {220/225, 180/225, 52/225},	-- content
	[3] = {143/255, 194/255, 32/255},	-- happy
}

oUF.colors.power = {
	['MANA']            = { 95/255, 155/255, 255/255 }, 
	['RAGE']            = { 250/255,  75/255,  60/255 }, 
	['FOCUS']           = { 255/255, 209/255,  71/255 },
	['ENERGY']          = { 200/255, 255/255, 200/255 }, 
	['RUNIC_POWER']     = {   0/255, 209/255, 255/255 },
	["AMMOSLOT"]		= { 200/255, 255/255, 200/255 },
	["FUEL"]			= { 250/255,  75/255,  60/255 },	
}

local colors = {
	class ={
	["DEATHKNIGHT"] = { 196/255,  30/255,  60/255 },
	["DRUID"]       = { 255/255, 125/255,  10/255 },
	["HUNTER"]      = { 171/255, 214/255, 116/255 },
	["MAGE"]        = { 104/255, 205/255, 255/255 },
	["PALADIN"]     = { 245/255, 140/255, 186/255 },
	["PRIEST"]      = { 212/255, 212/255, 212/255 },
	["ROGUE"]       = { 255/255, 243/255,  82/255 },
	["SHAMAN"]      = {  10/255, 164/255, 250/255 },	
	["WARLOCK"]     = { 148/255, 130/255, 201/255 },
	["WARRIOR"]     = { 199/255, 156/255, 110/255 },
	},
}

setmetatable(colors.class, {
	__index = function(self, key)
		return { 0.78, 0.61, 0.43 }
	end
})

local GetClassColor = function(unit)
	return unpack(colors.class[select(2, UnitClass(unit))])
end

-- health color gradient
oUF.colors.smooth = {1.0, 0.20, 0.00, 0.90, 0.80, 0.25, maincolor[1],maincolor[2],maincolor[3]}

local color_rb = 1.00
local color_gb = 1.00
local color_bb = 1.00
local alpha_fb = 1.00

local corb = 1
local cogb = 0
local cobb = 0

-- ------------------------------------------------------------------------
-- right click
-- ------------------------------------------------------------------------
local menu = function(self)
	local unit = self.unit:sub(1, -2)
	local cunit = self.unit:gsub("(.)", string.upper, 1)

	if(unit == "party" or unit == "partypet") then
		ToggleDropDownMenu(1, nil, _G["PartyMemberFrame"..self.id.."DropDown"], "cursor", 0, 0)
	elseif(_G[cunit.."FrameDropDown"]) then
		ToggleDropDownMenu(1, nil, _G[cunit.."FrameDropDown"], "cursor", 0, 0)
	end
end

-- ------------------------------------------------------------------------
-- Numbers magic
-- ------------------------------------------------------------------------
function round(num, idp)
  if idp and idp>0 then
    local mult = 10^idp
    return math.floor(num * mult + 0.5) / mult
  end
  return math.floor(num + 0.5)
end

function CoolNumber(num)
	if num>999 then
		return round(num/1e3,Numberzzz).."K"
	else
		return num
	end
end

-- ------------------------------------------------------------------------
-- More voodoo magic
-- ------------------------------------------------------------------------
local updateHealth = function(self, event, unit, bar, min, max)
    local d =(round(min/max, 2)*100)
	if(UnitIsDead(unit)) then
		bar:SetValue(0)
		bar.value:SetText"RIP"		
		bar.PERvalue:SetText(" ")
	elseif(UnitIsGhost(unit)) then
		bar:SetValue(0)
		bar.value:SetText"GHO"		
		bar.PERvalue:SetText(" ")
	elseif(not UnitIsConnected(unit)) then
		bar.value:SetText"OFF"	
		bar.PERvalue:SetText(" ")
	elseif(unit == "player") then
		if(d < 100) then
			bar.PERvalue:SetText((round(min/max, 2)*100))		
			bar.value:SetText(CoolNumber(min))
		else
			bar.PERvalue:SetText(" ")
			bar.value:SetText(CoolNumber(min))
		end	
	elseif(unit == "target")or(unit == "focus") then
		if(d < 100) then
		bar.PERvalue:SetText((round(min/max, 2)*100))
		end
		bar.value:SetText(CoolNumber(min))
	else
		bar.value:SetText(CoolNumber(min))	
		bar.PERvalue:SetText((round(min/max, 2)*100))
	end
	
	bar.value:SetTextColor(sndcolor[1], sndcolor[2], sndcolor[3])
	bar.PERvalue:SetTextColor(sndcolor[1], sndcolor[2], sndcolor[3])
	--bar.value:SetTextColor(maincolor[1],maincolor[2],maincolor[3])
	--bar.PERvalue:SetTextColor(maincolor[1],maincolor[2],maincolor[3])
end

local updatePower = function(self, event, unit, bar, min, max)
	local dp =(round(min/max, 2)*100)
	if(min == 0 or max == 0 or not UnitIsConnected(unit)) then
		bar.value:SetText()
		bar:SetValue(0)
	elseif(UnitIsDead(unit) or UnitIsGhost(unit)) then
		bar:SetValue(0)
	elseif(unit == "player") then
		if(dp < 100) then
		bar.value:SetText(CoolNumber(min))
		end
	elseif(unit == "target")or(unit == "focus") then
		bar.value:SetText(CoolNumber(min))
	else
		bar.value:SetText(CoolNumber(min))
	end

	bar.value:SetTextColor(sndcolor[1], sndcolor[2], sndcolor[3])
	--bar.value:SetTextColor(maincolor[1],maincolor[2],maincolor[3])

	-- hide power bar for npcs without power
	if unit=="target" then
			if ( UnitIsPlayer("target") ) then
			self.Power:Show()
			self.Power.bg:SetAlpha(0.6)
			else	
			if ( UnitPowerType("target") ~= 0 ) then
				self.Power:Hide()
				self.Power.bg:SetAlpha(0)
			end
		end
	end	
end

-- ------------------------------------------------------------------------
-- druid mana
-- ------------------------------------------------------------------------
oUF.TagEvents['[druidpower]'] = 'UNIT_MANA UPDATE_SHAPESHIFT_FORM'
oUF.Tags['[druidpower]'] = function(unit)
	local min, max = UnitPower(unit, 0), UnitPowerMax(unit, 0)
	return UnitPowerType(unit) ~= 0 and format('|cfdcdcdcf%d - %d%%|r', min, math.floor(min / max * 100))
end

local function updateDruidPower(self, event, unit)
	if(unit and unit ~= self.unit) then return end

	local mana = UnitPowerType('player') == 0
	local min, max = UnitPower('player', mana and 3 or 0), UnitPowerMax('player', mana and 3 or 0)

end

-- ------------------------------------
-- aura cancel on right click
-- ------------------------------------		
local function onMouseUp(self, button)
	if(button == 'RightButton') then
		CancelUnitBuff(self.frame.unit, self:GetID(), self.filter)
	end
end

-- ------------------------------------------------------------------------
-- aura reskin
-- ------------------------------------------------------------------------
local function auraIcon(self, icon, icons, index, debuff)
		icons.showDebuffType = true -- show debuff border type color 
		icon.cd.noOCC = true
		icon.cd.noCooldownCount = true
		icons.disableCooldown = true	
		
		icon.count:SetFont(font, fontS-2, fontF)
		icon.count:SetPoint("TOPRIGHT", icon, 4, 22)
	
		icon.time = icon:CreateFontString(nil, 'OVERLAY')
		icon.time:SetFont(font, fontS-2, fontF)
		icon.time:SetPoint('TOP', icon, 'BOTTOM', 0, 8)
		icon.time:SetJustifyH('CENTER')
		--icon.time:SetVertexColor(sndcolor[1], sndcolor[2], sndcolor[3])
		
		icon.icon:SetTexCoord(.07, .93, .07, .93)
		icon.icon:SetPoint("TOPLEFT", icon, "TOPLEFT", 3, -3)
		icon.icon:SetPoint("BOTTOMRIGHT", icon, "BOTTOMRIGHT", -3, 3)
		
		icon.overlay:SetTexture(bufftex)
		icon.overlay:SetTexCoord(0,1,0,1)
		icon.overlay.Hide = function(self) self:SetVertexColor(1,1,1) end
		--icon.overlay.Hide = function(self) self:SetVertexColor(sndcolor[1], sndcolor[2], sndcolor[3]) end
		--icon.overlay.Hide = function(self) self:SetVertexColor(maincolor[1],maincolor[2],maincolor[3]) end		
end

local function auraUpdateTime(self, elapsed)
	self.timeLeft = math.max(self.timeLeft - elapsed, 0)
	local timeFormat, value = SecondsToTimeAbbrev(math.floor(self.timeLeft))
	self.time:SetFormattedText(timeFormat, value)
end

local function auraUpdateTimeShort(self, elapsed)
	self.timeLeft = math.max(self.timeLeft - elapsed, 0)
	self.time:SetText(self.timeLeft < 60 and math.floor(self.timeLeft) or '')
end

local function auraUpdateIcon(self, icons, unit, icon, index, offset, filter, isDebuff)
	if(unit) or (self:GetParent():GetName():match"oUF_Party") then 
		local _, _, _, _, _, duration, timeLeft = UnitAura(unit, index, filter)
		
		if duration > 0 and timeLeft then
			icon.timeLeft = timeLeft - GetTime()
			
			if unit == 'player' then
				icon:SetScript('OnUpdate', auraUpdateTime)
			else
				icon:SetScript('OnUpdate', auraUpdateTimeShort)
			end
		else
			icon.timeLeft = nil
			icon.time:SetText()
			
			icon:SetScript('OnUpdate', nil)
		end
	end
end
--]] ------------------------------------------------------------------------
-- layout crap
-- ------------------------------------------------------------------------
local func = function(self, unit)
	self.menu = menu -- Enable the menus

	-- hide blizzard rune frame
	RuneFrame:Hide()
	-- hide blizzard buff and weapon buff frame
	BuffFrame:Hide()
	TemporaryEnchantFrame:Hide()
	
	self:SetScript("OnEnter", UnitFrame_OnEnter)
	self:SetScript("OnLeave", UnitFrame_OnLeave)
    
	self:RegisterForClicks"anyup"
	self:SetAttribute("*type2", "menu")
	
	-- healthbar
	self.Health = CreateFrame"StatusBar"
	self.Health:SetHeight(13)
	self.Health:SetStatusBarTexture(bartex)
    self.Health:SetParent(self)
	self.Health:SetPoint"TOP"
	self.Health:SetPoint"LEFT"
	self.Health:SetPoint"RIGHT"
	self.Health:SetFrameStrata("LOW")
	self.Health:SetFrameLevel(3)
	self.Health:SetStatusBarColor(maincolor[1],maincolor[2],maincolor[3])
	--self.Health:SetStatusBarColor(sndcolor[1], sndcolor[2], sndcolor[3])	
	self.Health.frequentUpdates = true

	self.Health.bg = self.Health:CreateTexture(nil, "BORDER")
	self.Health.bg:SetAllPoints(self.Health)
	self.Health.bg:SetTexture(bartex)
	self.Health.bg:SetAlpha(0.40)

	-- powerbar
	self.Power = CreateFrame"StatusBar"
	self.Power:SetHeight(3)
	self.Power:SetStatusBarTexture(bartex)
	self.Power:SetParent(self)
	self.Power:SetPoint("TOP", self.Health, "BOTTOM", 0, 0)
	self.Power:SetFrameStrata("LOW")
	self.Power:SetFrameLevel(3)	
	self.Power.frequentUpdates = true
	self.Power:SetAlpha(0.8)

	self.Power.bg = self.Power:CreateTexture(nil, "BORDER")
	self.Power.bg:SetAllPoints(self.Power)
	self.Power.bg:SetTexture(bartex)
	self.Power.bg:SetAlpha(0.0)  

	self.Power.colorTapping = true 
	self.Power.colorDisconnected = true 
	self.Power.colorClass = true 
	self.Power.colorPower = true 
	self.Power.colorHappiness = false  
	self.PostUpdatePower = updatePower -- let the colors be  

	-- ------------------------------------------------------------------------
	-- Text fields |cff00DBBA
	-- ------------------------------------------------------------------------
	self.Health.value = self.Health:CreateFontString(nil, "ARTWORK")
	self.Health.value:SetFont(font, fontS+18, fontF)
	
	self.Health.PERvalue = self.Health:CreateFontString(nil, "ARTWORK")
	self.Health.PERvalue:SetFont(font, fontS, fontF)

	self.Power.value = self.Power:CreateFontString(nil, "ARTWORK")
	self.Power.value:SetFont(font, fontS, fontF)
	
	self.Name = self.Health:CreateFontString(nil, "ARTWORK")
	self.Name:SetJustifyH("CENTER")
	self.Name:SetFont(fontN, fontSN, fontF)
	self:Tag(self.Name, '[raidcolor][name]')

	self.Level = self.Health:CreateFontString(nil, "ARTWORK")
	self.Level:SetJustifyH("CENTER")
	self.Level:SetFont(font, fontS, fontF)
	self:Tag(self.Level, '[difficulty][smartlevel]')

	-- oUF Tags Holder Frame
	local oUFTagHolder = CreateFrame("Frame", nil, UIParent)
	local OUFTH = oUFTagHolder:CreateTexture(nil,"BACKGROUND")
	oUFTagHolder:SetPoint("CENTER", self, "CENTER", 0, 0)
	oUFTagHolder:SetFrameStrata("LOW")
	oUFTagHolder:SetFrameLevel(10)
	OUFTH:SetVertexColor(0,0,0,0)	
	OUFTH:SetAllPoints(oUFTagHolder)
	oUFTagHolder.texture = OUFTH
	oUFTagHolder:Show()	
		
	self.Name:SetParent(oUFTagHolder)
	self.Level:SetParent(oUFTagHolder)
	self.Health.value:SetParent(oUFTagHolder)
	self.Health.PERvalue:SetParent(oUFTagHolder)
	self.Power.value:SetParent(oUFTagHolder)
	
	-- ------------------------------------
	-- Combat Feedback for all frames
	-- ------------------------------------			
	local cbft = self.Health:CreateFontString(nil, "OVERLAY")
		cbft:SetPoint("CENTER", self.Health, "CENTER", 0, 0)
		cbft:SetFontObject(GameFontNormal)
		self.CombatFeedbackText = cbft	
		self.CombatFeedbackText:SetFont(font, 18, "OUTLINE")	
		self.CombatFeedbackText:SetParent(oUFTagHolder)
		
	-- ------------------------------------	
	-- oUF_SpellRange fading and oUF_Smooth support for all frames
	-- ------------------------------------	
		if(unit) or (self:GetParent():GetName():match"oUF_Raid") or (self:GetParent():GetName():match"oUF_Party") then 
		self.SpellRange = true; -- fadeout if units are out of range
		self.inRangeAlpha = 1.0; -- Frame alpha when in range
		self.outsideRangeAlpha = 0.3; -- Frame alpha when out of range
		self.Power.Smooth = true
		self.Health.Smooth = true
		self.MoveableFrames = true		
		end

	-- ------------------------------------
	-- health color gradient for player, party, raid, pet
	-- ------------------------------------		
	if unit=="player" or unit=="pet" or (self:GetParent():GetName():match"oUF_Party") or (self:GetParent():GetName():match"oUF_Raid")then	
		self.Health.colorSmooth = true		
	end
	
	-- ------------------------------------
	-- oUF_DebuffHighlight support - border highlight
	-- ------------------------------------
	if unit=="player" or unit=="target" or unit=="pet" or (self:GetParent():GetName():match"oUF_Party") then
		self.DebuffHighlight = self:CreateTexture(nil, "OVERLAY")
		self.DebuffHighlight:SetPoint("TOPLEFT",self,"TOPLEFT",-4,4)
		self.DebuffHighlight:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",4,-4)
		self.DebuffHighlight:SetTexture(borderDebuffHigh)
		self.DebuffHighlight:SetVertexColor(0, 0, 0, 0)
		self.DebuffHighlight:SetBlendMode("ADD")
		self.DebuffHighlightAlpha = 0.9
		self.DebuffHighlightFilter = true
	elseif(self:GetParent():GetName():match"oUF_Raid") then
		self.DebuffHighlight = self:CreateTexture(nil, "OVERLAY")
		self.DebuffHighlight:SetPoint("TOPLEFT",self,"TOPLEFT",-2,2)
		self.DebuffHighlight:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",2,-2)
		self.DebuffHighlight:SetTexture(bartex)
		self.DebuffHighlight:SetVertexColor(0, 0, 0, 0)
		self.DebuffHighlight:SetBlendMode("ADD")
		self.DebuffHighlightAlpha = 1.0
		self.DebuffHighlightFilter = true
	end

	-- ------------------------------------
	-- raid target icons for all frames
	-- ------------------------------------
	if unit=="player" or unit=="target" or unit=="targettarget" or unit=="focus" or unit=="pet" or (self:GetParent():GetName():match"oUF_Party") or (self:GetParent():GetName():match"oUF_Raid") then
		self.RaidIcon = self.Health:CreateTexture(nil, "OVERLAY")
		self.RaidIcon:SetHeight(14)
		self.RaidIcon:SetWidth(14)
		self.RaidIcon:SetPoint("CENTER", self, 0, 12)
		self.RaidIcon:SetTexture"Interface\\TargetingFrame\\UI-RaidTargetingIcons"
		self.RaidIcon:SetParent(oUFTagHolder)
	end

	-- ------------------------------------
	-- afk icon
	-- ------------------------------------		
		local afkIcon = self.Health:CreateTexture(nil, "OVERLAY")
		afkIcon:SetPoint("CENTER", self, "CENTER", 0, 12)
		afkIcon:SetWidth(24)
		afkIcon:SetHeight(24)
		afkIcon:Hide()
		self.AFKIcon = afkIcon
		self.AFKIconTexture = "Interface\\AddOns\\oUF_Aion\\Art\\afk.tga"
		self.AFKIcon:SetParent(oUFTagHolder)
	
	-- ------------------------------------
	-- player
	-- ------------------------------------
	if unit=="player" then
		oUFTagHolder:SetParent(oUF_Player)
	
		self:SetWidth(234)
		self:SetHeight(22)
		self.Health:SetWidth(234)
		self.Health:SetHeight(16)		

		self.Health.value:SetPoint("TOPRIGHT", self.Health, "TOPLEFT", -56, 2)			
		--self.Health.value:SetPoint("TOPLEFT", self.Health, "TOPRIGHT", 50, 2)
		self.Power.value:SetPoint("LEFT", self.Health, "LEFT", 6, 0)
		self.Health.PERvalue:SetPoint("RIGHT", self.Health, "RIGHT", -6, 0)
			
		self.Power:SetPoint("TOP", self.Health, "BOTTOM", 0, 37) 
		self.Power:SetStatusBarTexture("Interface\\AddOns\\oUF_Aion\\Art\\playerMana")
		self.Power:SetWidth(234)
		self.Power:SetHeight(62)	
		
		self.Power.bg:SetAlpha(0.1)  
		self.Power.bg:SetAllPoints(self.Power)
		self.Power.bg:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\playerMana")
	
		self.ignoreBanzai = true
		self.BarFade = true

		self.DebuffHighlight:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\playerDebuff")	
		self.DebuffHighlight:SetPoint("TOPLEFT",self,"TOPLEFT",-79,39)
		self.DebuffHighlight:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",46,-35)

		local PlayerBG = CreateFrame("Frame", nil, oUF_Player)
		local PBG = PlayerBG:CreateTexture(nil,"BACKGROUND")
		PlayerBG:SetPoint("CENTER", self, "CENTER", -16, 2)
		PlayerBG:SetWidth(360) 
		PlayerBG:SetHeight(95)
		PlayerBG:SetFrameStrata("BACKGROUND")
		PlayerBG:SetFrameLevel(1)
		PBG:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\PlayerBG")		
		PBG:SetVertexColor(1,1,1,1)	
		PBG:SetAllPoints(PlayerBG)
		PlayerBG.texture = PBG
		PlayerBG:Show()	

		local PlayerBG2 = CreateFrame("Frame", nil, oUF_Player)
		local PBG2 = PlayerBG2:CreateTexture(nil,"BACKGROUND")
		PlayerBG2:SetPoint("CENTER", self, "CENTER", -16, 2)
		PlayerBG2:SetWidth(360) 
		PlayerBG2:SetHeight(95)
		PlayerBG2:SetFrameStrata("LOW")
		PlayerBG2:SetFrameLevel(5)
		PBG2:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\Player")		
		PBG2:SetVertexColor(1,1,1,1)	
		PBG2:SetAllPoints(PlayerBG2)
		PlayerBG2.texture = PBG2
		PlayerBG2:Show()	

		local portrait = CreateFrame("PlayerModel", nil, self)
		portrait:SetScript("OnShow", function(self) self:SetCamera(0) end)
		portrait:SetWidth(37)
		portrait:SetHeight(37)
		portrait:SetPoint("TOPLEFT", self.Health, "TOPLEFT", -47, 8)
		portrait.type = "3D"
		self.Portrait = portrait
		portrait:SetFrameStrata("LOW")		
		portrait:SetFrameLevel(1)

		local PorPlaBG = CreateFrame("Frame", nil, oUF_Player)
		local PORPLABG2 = PorPlaBG:CreateTexture(nil,"BACKGROUND")
		PorPlaBG:SetPoint("CENTER", portrait, "CENTER", 2, 2)
		PorPlaBG:SetWidth(46) 
		PorPlaBG:SetHeight(47)
		PorPlaBG:SetFrameStrata("LOW")
		PorPlaBG:SetFrameLevel(6)
		PORPLABG2:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\GlowRoundShape")		
		PORPLABG2:SetVertexColor(1,1,1,1)	
		PORPLABG2:SetAllPoints(PorPlaBG)
		PorPlaBG.texture = PORPLABG2
		PorPlaBG:Show()	

		if playerClass=="DRUID" then
			local value = self.Power:CreateFontString(nil, 'OVERLAY')
			value:SetPoint("TOP", self, "BOTTOM", 0, 0)		
			value:SetFont(font, fontS-4, fontF)
			self:Tag(value, '[druidpower]')

			value:SetParent(oUFTagHolder)
			table.insert(self.__elements, updateDruidPower)
			self:RegisterEvent('UNIT_MANA', updateDruidPower)
			self:RegisterEvent('UNIT_ENERGY', updateDruidPower)
			self:RegisterEvent('UPDATE_SHAPESHIFT_FORM', updateDruidPower)
		end

		if(IsAddOnLoaded('oUF_Swing')) and playerClass=="HUNTER" then

			self.Swing = CreateFrame('StatusBar', nil, self)
			self.Swing:SetPoint("CENTER", UIParent, "CENTER", 0, -120)			
			self.Swing:SetStatusBarTexture(bartex)
			self.Swing:SetStatusBarColor(0.67, 0.83, 0.45)
			--self.Swing:SetStatusBarColor(0.2, 0.2, 0.2, 0.8)			
			self.Swing:SetHeight(4)
			self.Swing:SetWidth(220)
			self.Swing.disableMelee = true
			self.Swing:SetFrameLevel(1)
			
			self.Swing.bg = self.Swing:CreateTexture(nil, "BORDER")
			self.Swing.bg:SetAllPoints(self.Swing)
			self.Swing.bg:SetTexture(bartex)
			self.Swing.bg:SetAlpha(0.40)
			self.Swing.bg:SetVertexColor(0, 0, 0)
			
			self.Swing.Text = self.Swing:CreateFontString(nil, 'OVERLAY')
			self.Swing.Text:SetFont(font, fontS-3, fontF)
			self.Swing.Text:SetPoint('CENTER', self.Swing, 0, -10)
		end

		self.Buffs = CreateFrame("Frame", nil, self)
		self.Buffs.size = 32
		self.Buffs:SetHeight(300)
		self.Buffs:SetWidth(340)
		self.Buffs:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -30, -20)
		self.Buffs.initialAnchor = "TOPRIGHT"
		self.Buffs["growth-y"] = "DOWN"
		self.Buffs["growth-x"] = "LEFT"
		self.Buffs.num = 40
		self.Buffs.spacing = 3
		
		self.Debuffs = CreateFrame("Frame", nil, self)
		self.Debuffs.size = 32
		self.Debuffs:SetHeight(300)
		self.Debuffs:SetWidth(340)
		self.Debuffs:SetPoint("TOP", self.Buffs, "BOTTOM", 0, 140)
		self.Debuffs.initialAnchor = "TOPRIGHT"
		self.Debuffs["growth-y"] = "DOWN"
		self.Debuffs["growth-x"] = "LEFT"
		self.Debuffs.num = 40
		self.Debuffs.spacing = 3
		
		self.Combat = self.Health:CreateTexture(nil, 'OVERLAY')
		self.Combat:SetHeight(16)
		self.Combat:SetWidth(16)
		self.Combat:SetPoint("TOPLEFT", self, 16, 20)	
		self.Combat:SetTexture('Interface\\CharacterFrame\\UI-StateIcon')
		self.Combat:SetTexCoord(0.58, 0.90, 0.08, 0.41)
		self.Combat:SetParent(oUFTagHolder)

		self.Resting = self.Health:CreateTexture(nil, 'OVERLAY')
		self.Resting:SetHeight(16)
		self.Resting:SetWidth(16)
		self.Resting:SetPoint('RIGHT', self.Combat, 4, 0)
		self.Resting:SetTexture('Interface\\CharacterFrame\\UI-StateIcon')
		self.Resting:SetTexCoord(0,0.5,0,0.421875)
		self.Resting:SetParent(oUFTagHolder)
		
		self.Leader = self.Health:CreateTexture(nil, "OVERLAY")
		self.Leader:SetHeight(16)
		self.Leader:SetWidth(16)
		self.Leader:SetPoint('RIGHT', self.Resting, 4, 0)
		self.Leader:SetTexture"Interface\\GroupFrame\\UI-Group-LeaderIcon"
		self.Leader:SetParent(oUFTagHolder)		

		self.Spark = self.Power:CreateTexture(nil, "OVERLAY")
		self.Spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
		self.Spark:SetVertexColor(1, 1, 1, 1)
		self.Spark:SetBlendMode("ADD")
		self.Spark:SetHeight(self.Power:GetHeight()*1.5)
		self.Spark:SetWidth(4)			
	end

	-- ------------------------------------
	-- pet
	-- ------------------------------------
	if unit=="pet" then
		oUFTagHolder:SetParent(oUF_Pet)	
		
		self:SetWidth(135)
		self:SetHeight(18)
		self.Health:SetWidth(135)
		self.Health:SetHeight(16)	
		self.Power:Hide() 
		self.Name:SetWidth(200)
		self.Name:SetPoint("BOTTOM", self.Health, "TOP", 0, 2)	
		self.Health.PERvalue:SetPoint("RIGHT", self.Health, "RIGHT", -4, 0)
		
		self.DebuffHighlight:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\ToTDebuff")	
		self.DebuffHighlight:SetPoint("TOPLEFT",self,"TOPLEFT",-85,40)
		self.DebuffHighlight:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",85,-40)	

		local PetBG = CreateFrame("Frame", nil, oUF_Pet)
		local PETBG1 = PetBG:CreateTexture(nil,"BACKGROUND")
		PetBG:SetPoint("CENTER", self, "CENTER", 0, 1)
		PetBG:SetWidth(308) 
		PetBG:SetHeight(95)
		PetBG:SetFrameStrata("BACKGROUND")
		PetBG:SetFrameLevel(1)
		PETBG1:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\ToTBG")		
		PETBG1:SetVertexColor(1,1,1,1)	
		PETBG1:SetAllPoints(PetBG)
		PetBG.texture = PETBG1
		PetBG:Show()	

		local PetBG2 = CreateFrame("Frame", nil, oUF_Pet)
		local PETBG3 = PetBG2:CreateTexture(nil,"BACKGROUND")
		PetBG2:SetPoint("CENTER", self, "CENTER", 0, 1)
		PetBG2:SetWidth(308) 
		PetBG2:SetHeight(95)
		PetBG2:SetFrameStrata("LOW")
		PetBG2:SetFrameLevel(5)
		PETBG3:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\ToT")		
		PETBG3:SetVertexColor(1,1,1,1)	
		PETBG3:SetAllPoints(PetBG2)
		PetBG2.texture = PETBG3
		PetBG2:Show()		

		self.BarFade = true
		
		if playerClass=="HUNTER" then
			self.Health.colorReaction = false
			self.Health.colorClass = false
			self.Health.colorHappiness = true  
		end
	end

	-- ------------------------------------
	-- target
	-- ------------------------------------
    if unit=="target" then
		oUFTagHolder:SetParent(oUF_Target)
		
		self:SetWidth(234)
		self:SetHeight(18)
		self.Health:SetHeight(16)			
		self.Health:SetWidth(234)		
		self.Level:SetPoint("TOPRIGHT", self.Health, "TOPLEFT", -48, 0)		
		self.Name:SetPoint("BOTTOM", self.Health, "TOP", 0, 10)		
		self.Name:SetWidth(210)		

		self.Health.value:SetPoint("TOPRIGHT", self.Health, "TOPLEFT", -78, 4)		
		self.Power.value:Hide()
		self.Health.PERvalue:ClearAllPoints()
		self.Health.PERvalue:SetPoint("LEFT", self.Health, "LEFT", 6, 0)		
		
		self.Power:SetPoint("TOP", self.Health, "BOTTOM", 10, 39) 
		self.Power:SetStatusBarTexture("Interface\\AddOns\\oUF_Aion\\Art\\TargetMana")
		self.Power:SetWidth(278)
		self.Power:SetHeight(70)
		
		self.Power.bg:SetAlpha(0)  
		self.Power.bg:SetAllPoints(self.Power)
		self.Power.bg:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\TargetMana")		

		self.DebuffHighlight:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\TargetDebuff")	
		self.DebuffHighlight:SetPoint("TOPLEFT",self,"TOPLEFT",-75,40)
		self.DebuffHighlight:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",58,-40)
	
		local TargetBG = CreateFrame("Frame", nil, oUF_Target)
		local TBG = TargetBG:CreateTexture(nil,"BACKGROUND")
		TargetBG:SetPoint("CENTER", self, "CENTER", -8, 0)
		TargetBG:SetWidth(365) 
		TargetBG:SetHeight(95)
		TargetBG:SetFrameStrata("BACKGROUND")
		TargetBG:SetFrameLevel(1)
		TBG:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\TargetBG")		
		TBG:SetVertexColor(1,1,1,1)	
		TBG:SetAllPoints(TargetBG)
		TargetBG.texture = TBG
		TargetBG:Show()	

		local TargetBG2 = CreateFrame("Frame", nil, oUF_Target)
		local TBG2 = TargetBG2:CreateTexture(nil,"BACKGROUND")
		TargetBG2:SetPoint("CENTER", self, "CENTER", -8, 0)
		TargetBG2:SetWidth(365) 
		TargetBG2:SetHeight(95)
		TargetBG2:SetFrameStrata("LOW")
		TargetBG2:SetFrameLevel(5)
		TBG2:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\Target")		
		TBG2:SetVertexColor(1,1,1,1)	
		TBG2:SetAllPoints(TargetBG2)
		TargetBG2.texture = TBG2
		TargetBG2:Show()	

		local portrait = CreateFrame("PlayerModel", nil, self)
		portrait:SetScript("OnShow", function(self) self:SetCamera(0) end)
		portrait:SetWidth(35)
		portrait:SetHeight(35)
		portrait:SetPoint("TOPLEFT", self.Health, "TOPLEFT", -47, 10)
		portrait.type = "3D"
		self.Portrait = portrait
		portrait:SetFrameStrata("LOW")		
		portrait:SetFrameLevel(1)	

		local PorTarBG = CreateFrame("Frame", nil, oUF_Target)
		local PORTARBG2 = PorTarBG:CreateTexture(nil,"BACKGROUND")
		PorTarBG:SetPoint("CENTER", portrait, "CENTER", 0, 0)
		PorTarBG:SetWidth(47) 
		PorTarBG:SetHeight(47)
		PorTarBG:SetFrameStrata("LOW")
		PorTarBG:SetFrameLevel(6)
		PORTARBG2:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\GlowRoundShape")		
		PORTARBG2:SetVertexColor(1,1,1,1)	
		PORTARBG2:SetAllPoints(PorTarBG)
		PorTarBG.texture = PORTARBG2
		PorTarBG:Show()		

		local pvp = self.Health:CreateTexture(nil, "OVERLAY")
		pvp:SetPoint("RIGHT", self.Health, "RIGHT", 38, -6)
		pvp:SetHeight(30)
		pvp:SetWidth(30)
		self.PvP = pvp
		self.PvP:SetParent(oUFTagHolder)	
		
		if TargetAurasOnTOP == true then		
		self.Auras = CreateFrame("Frame", nil, self)
		self.Auras.size = 32
		self.Auras.gap = true
		self.Auras:SetHeight(self.Auras.size)
		self.Auras:SetWidth(self.Auras.size * 8)
		self.Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", -16, 36)
		self.Auras.initialAnchor = "TOPLEFT"
		self.Auras["growth-y"] = "TOP"
		self.Auras.numBuffs = 40
		self.Auras.numDebuffs = 40
		self.Auras.spacing = 2
		self.Auras.debuffFilter = "HARMFUL|PLAYER"
		self.Auras:SetFrameStrata("LOW")
		self.Auras:SetFrameLevel(10)
		else
		self.Auras = CreateFrame("Frame", nil, self)
		self.Auras.size = 32
		self.Auras.gap = true
		self.Auras:SetHeight(self.Auras.size)
		self.Auras:SetWidth(self.Auras.size * 8)
		self.Auras:SetPoint("TOPLEFT", self, "BOTTOMLEFT", -16, -36)
		self.Auras.initialAnchor = "TOPLEFT"
		self.Auras["growth-y"] = "DOWN"
		self.Auras.numBuffs = 40
		self.Auras.numDebuffs = 40
		self.Auras.spacing = 2
		self.Auras.debuffFilter = "HARMFUL|PLAYER"
		self.Auras:SetFrameStrata("LOW")
		self.Auras:SetFrameLevel(10)	
		end		
	end


	-- ------------------------------------
	-- target of target and focus
	-- ------------------------------------
	if unit=="targettarget" then
	oUFTagHolder:SetParent(oUF_TargetTarget)	
	
	self:SetWidth(120)
	self:SetHeight(18)
	self.Health:SetWidth(120)
	self.Health:SetHeight(16)	
	self.Power:Hide() 
	self.Name:SetWidth(200)
	self.Name:SetPoint("BOTTOM", self.Health, "TOP", 0, 0)	
	self.Health.PERvalue:SetPoint("RIGHT", self.Health, "RIGHT", -4, 0)		
	
		local ToTBG = CreateFrame("Frame", nil, oUF_TargetTarget)
		local TBG1 = ToTBG:CreateTexture(nil,"BACKGROUND")
		ToTBG:SetPoint("CENTER", self, "CENTER", 0, 1)
		ToTBG:SetWidth(278) 
		ToTBG:SetHeight(95)
		ToTBG:SetFrameStrata("BACKGROUND")
		ToTBG:SetFrameLevel(1)
		TBG1:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\ToTBG")		
		TBG1:SetVertexColor(1,1,1,1)	
		TBG1:SetAllPoints(ToTBG)
		ToTBG.texture = TBG1
		ToTBG:Show()	

		local ToTBG2 = CreateFrame("Frame", nil, oUF_TargetTarget)
		local TOTBG3 = ToTBG2:CreateTexture(nil,"BACKGROUND")
		ToTBG2:SetPoint("CENTER", self, "CENTER", 0, 1)
		ToTBG2:SetWidth(278) 
		ToTBG2:SetHeight(95)
		ToTBG2:SetFrameStrata("LOW")
		ToTBG2:SetFrameLevel(5)
		TOTBG3:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\ToT")		
		TOTBG3:SetVertexColor(1,1,1,1)	
		TOTBG3:SetAllPoints(ToTBG2)
		ToTBG2.texture = TOTBG3
		ToTBG2:Show()		
	end

	if unit=="focus" then	
	oUFTagHolder:SetParent(oUF_Focus)
	
	self:SetWidth(120)
	self:SetHeight(18)
	self.Health:SetWidth(120)
	self.Health:SetHeight(16)	
	self.Power:Hide() 
	self.Name:SetWidth(200)
	self.Name:SetPoint("BOTTOM", self.Health, "TOP", 0, 0)	
	self.Health.PERvalue:SetPoint("RIGHT", self.Health, "RIGHT", -4, 0)
		
		local FocusBG = CreateFrame("Frame", nil, oUF_Focus)
		local FBG1 = FocusBG:CreateTexture(nil,"BACKGROUND")
		FocusBG:SetPoint("CENTER", self, "CENTER", 0, 1)
		FocusBG:SetWidth(278) 
		FocusBG:SetHeight(95)
		FocusBG:SetFrameStrata("BACKGROUND")
		FocusBG:SetFrameLevel(1)
		FBG1:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\ToTBG")		
		FBG1:SetVertexColor(1,1,1,1)	
		FBG1:SetAllPoints(FocusBG)
		FocusBG.texture = FBG1
		FocusBG:Show()	

		local FocusBG2 = CreateFrame("Frame", nil, oUF_Focus)
		local FBG3 = FocusBG2:CreateTexture(nil,"BACKGROUND")
		FocusBG2:SetPoint("CENTER", self, "CENTER", 0, 1)
		FocusBG2:SetWidth(278) 
		FocusBG2:SetHeight(95)
		FocusBG2:SetFrameStrata("LOW")
		FocusBG2:SetFrameLevel(5)
		FBG3:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\ToT")		
		FBG3:SetVertexColor(1,1,1,1)	
		FBG3:SetAllPoints(FocusBG2)
		FocusBG2.texture = FBG3
		FocusBG2:Show()		
	end
	
	-- ------------------------------------
	-- player and target castbar
	-- ------------------------------------	
	if(unit == 'player' or unit == 'target') then
	    self.Castbar = CreateFrame('StatusBar', nil, self)
	    self.Castbar:SetStatusBarTexture(bartex)
		self.Castbar:SetFrameStrata("LOW")
		self.Castbar:SetFrameLevel(3)
		
		if(unit == "player") then
			--self.Castbar:SetStatusBarColor(GetClassColor(unit))
			self.Castbar:SetStatusBarColor(maincolor[1],maincolor[2],maincolor[3]) 
			self.Castbar:SetHeight(10)
			self.Castbar:SetWidth(220)

			self.Castbar.SafeZone = self.Castbar:CreateTexture(nil,"ARTWORK")
			self.Castbar.SafeZone:SetTexture(bartex)
			self.Castbar.SafeZone:SetVertexColor(.75,.10,.10,.7)
			self.Castbar.SafeZone:SetPoint("TOPRIGHT")
			self.Castbar.SafeZone:SetPoint("BOTTOMRIGHT")
			
			self.Castbar:SetPoint('CENTER', UIParent, 'CENTER', playerCastBar_x, playerCastBar_y)
			
		else
			self.Castbar:SetStatusBarColor(0.80, 0.01, 0)
			self.Castbar:SetHeight(10)
			self.Castbar:SetWidth(220)
			
			self.Castbar:SetPoint('CENTER', UIParent, 'CENTER', targetCastBar_x, targetCastBar_y)
		end
		
		self.Castbar:SetBackdropColor(0, 0, 0, 0.5)
		
		self.Castbar.Text = self.Castbar:CreateFontString(nil, 'OVERLAY')
	    self.Castbar.Text:SetPoint('LEFT', self.Castbar, 0, -30)
	    self.Castbar.Text:SetFont(fontN, fontSN-2, fontF)
	    self.Castbar.Text:SetTextColor(sndcolor[1], sndcolor[2], sndcolor[3])
	    self.Castbar.Text:SetJustifyH('LEFT')

	    self.Castbar.Time = self.Castbar:CreateFontString(nil, 'OVERLAY')
	    self.Castbar.Time:SetPoint('RIGHT', self.Castbar, 0, -30)
	    self.Castbar.Time:SetFont(font, fontS-2, fontF)
	    self.Castbar.Time:SetTextColor(sndcolor[1], sndcolor[2], sndcolor[3])
	    self.Castbar.Time:SetJustifyH('RIGHT')

		local CastbarBG = CreateFrame("Frame", nil, self.Castbar)
		local CBG = CastbarBG:CreateTexture(nil,"BACKGROUND")
		CastbarBG:SetPoint("CENTER", self.Castbar, "CENTER", 0, 0)
		CastbarBG:SetWidth(300) 
		CastbarBG:SetHeight(34)
		CastbarBG:SetFrameStrata("BACKGROUND")
		CastbarBG:SetFrameLevel(1)
		CBG:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\CastbarBG")		
		CBG:SetVertexColor(1,1,1,1)	
		CBG:SetAllPoints(CastbarBG)
		CastbarBG.texture = CBG
		CastbarBG:Show()	

		local CastbarBG2 = CreateFrame("Frame", nil, self.Castbar)
		local CBG2 = CastbarBG2:CreateTexture(nil,"BACKGROUND")
		CastbarBG2:SetPoint("CENTER", self.Castbar, "CENTER", 0, 0)
		CastbarBG2:SetWidth(300) 
		CastbarBG2:SetHeight(34)
		CastbarBG2:SetFrameStrata("LOW")
		CastbarBG2:SetFrameLevel(5)
		CBG2:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\Castbar")		
		CBG2:SetVertexColor(1,1,1,1)	
		CBG2:SetAllPoints(CastbarBG2)
		CastbarBG2.texture = CBG2
		CastbarBG2:Show()
		
		if(unit == "target") then
		self.Castbar:SetScale(TarCastScale)
		end
	end

	-- ------------------------------------
	-- party 
	-- ------------------------------------
	if(self:GetParent():GetName():match"oUF_Party") then
	oUFTagHolder:SetParent(self)

		self.Health.value:SetPoint("TOPRIGHT", self.Health, "TOPLEFT", -74, 4)
		self.Power.value:SetPoint("LEFT", self.Health, "LEFT", 6, 0)
		self.Health.PERvalue:SetPoint("RIGHT", self.Health, "RIGHT", -6, 0)
		
		self:SetWidth(125)
		self:SetHeight(18)
		self.Health:SetHeight(17)			
		self.Health:SetWidth(125)
		self.Name:SetPoint("BOTTOM", self.Health, "TOP", 0, 10)			
		self.Level:SetPoint("TOPRIGHT", self.Name, "TOPLEFT", -3, 0)
		
		self.Power:SetPoint("TOP", self.Health, "BOTTOM", 0, 34) 
		self.Power:SetStatusBarTexture("Interface\\AddOns\\oUF_Aion\\Art\\partymemberMana")
		self.Power:SetWidth(216)
		self.Power:SetHeight(53)	
		
		self.Power.bg:SetAlpha(0.1)  
		self.Power.bg:SetAllPoints(self.Power)
		self.Power.bg:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\partymemberMana")		

		self.DebuffHighlight:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\partyDebuff")	
		self.DebuffHighlight:SetPoint("TOPLEFT",self,"TOPLEFT",-159,45)
		self.DebuffHighlight:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",101,-45)	

		local PartyMBG = CreateFrame("Frame", nil, self)
		local PMBG = PartyMBG:CreateTexture(nil,"BACKGROUND")
		PartyMBG:SetPoint("CENTER", self, "CENTER", -30, 0)
		PartyMBG:SetWidth(460) 
		PartyMBG:SetHeight(110)
		PartyMBG:SetFrameStrata("BACKGROUND")
		PartyMBG:SetFrameLevel(1)
		PMBG:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\partymemberBG")		
		PMBG:SetVertexColor(1,1,1,1)	
		PMBG:SetAllPoints(PartyMBG)
		PartyMBG.texture = PMBG
		PartyMBG:Show()	

		local PartyMBG2 = CreateFrame("Frame", nil, self)
		local PMBG2 = PartyMBG2:CreateTexture(nil,"BACKGROUND")
		PartyMBG2:SetPoint("CENTER", self, "CENTER", -30, 0)
		PartyMBG2:SetWidth(460) 
		PartyMBG2:SetHeight(110)
		PartyMBG2:SetFrameStrata("LOW")
		PartyMBG2:SetFrameLevel(5)
		PMBG2:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\partymember")		
		PMBG2:SetVertexColor(1,1,1,1)	
		PMBG2:SetAllPoints(PartyMBG2)
		PartyMBG2.texture = PMBG2
		PartyMBG2:Show()	

		local portrait = CreateFrame("PlayerModel", nil, self)
		portrait:SetScript("OnShow", function(self) self:SetCamera(0) end)
		portrait:SetWidth(43)
		portrait:SetHeight(43)
		portrait:SetPoint("TOPLEFT", self.Health, "TOPLEFT", -60, 11)
		portrait.type = "3D"
		self.Portrait = portrait
		portrait:SetFrameStrata("LOW")		
		portrait:SetFrameLevel(2)

		local ParMemBG = CreateFrame("Frame", nil, self)
		local PARMEMBG2 = ParMemBG:CreateTexture(nil,"BACKGROUND")
		ParMemBG:SetPoint("CENTER", portrait, "CENTER", 0, 0)
		ParMemBG:SetWidth(61) 
		ParMemBG:SetHeight(57)
		ParMemBG:SetFrameStrata("LOW")
		ParMemBG:SetFrameLevel(6)
		PARMEMBG2:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\GlowRoundShape")		
		PARMEMBG2:SetVertexColor(1,1,1,1)	
		PARMEMBG2:SetAllPoints(ParMemBG)
		ParMemBG.texture = PARMEMBG2
		ParMemBG:Show()			

		self.Leader = self.Health:CreateTexture(nil, "OVERLAY")
		self.Leader:SetHeight(14)
		self.Leader:SetWidth(14)
		self.Leader:SetPoint("BOTTOMLEFT", self, 2, 19)
		self.Leader:SetTexture"Interface\\GroupFrame\\UI-Group-LeaderIcon"
		self.Leader:SetParent(oUFTagHolder)

		self.Auras = CreateFrame("Frame", nil, self) -- auras
		self.Auras.buffFilter= "HELPFUL|RAID"
		self.Auras.size = 24
		self.Auras.gap = true
		self.Auras:SetHeight(self.Auras.size)
		self.Auras:SetWidth(self.Auras.size * 9)
		self.Auras:SetPoint("BOTTOMLEFT", self, "BOTTOMLEFT", -4, -40)
		self.Auras.initialAnchor = "BOTTOMLEFT"
		self.Auras.numBuffs = 5
		self.Auras.numDebuffs = 3
		self.Auras.spacing = 2

	end

	-- ------------------------------------
	-- partypets
	-- ------------------------------------
if usepartypets == true then	
	if(unit and unit:find('partypet%d')) then
	oUFTagHolder:SetParent(self)
	
	self:SetWidth(135)
	self:SetHeight(18)
	self.Health:SetWidth(135)
	self.Health:SetHeight(16)	
	self.Power:Hide() 
	self.Name:SetWidth(200)
	self.Name:SetPoint("BOTTOM", self.Health, "TOP", 0, 2)			
	
		local PaPetBG = CreateFrame("Frame", nil, self)
		local PPETBG1 = PaPetBG:CreateTexture(nil,"BACKGROUND")
		PaPetBG:SetPoint("CENTER", self, "CENTER", 0, 1)
		PaPetBG:SetWidth(308) 
		PaPetBG:SetHeight(95)
		PaPetBG:SetFrameStrata("BACKGROUND")
		PaPetBG:SetFrameLevel(1)
		PPETBG1:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\ToTBG")		
		PPETBG1:SetVertexColor(1,1,1,1)	
		PPETBG1:SetAllPoints(PaPetBG)
		PaPetBG.texture = PPETBG1
		PaPetBG:Show()	

		local PaPetBG2 = CreateFrame("Frame", nil, self)
		local PPETBG3 = PaPetBG2:CreateTexture(nil,"BACKGROUND")
		PaPetBG2:SetPoint("CENTER", self, "CENTER", 0, 1)
		PaPetBG2:SetWidth(308) 
		PaPetBG2:SetHeight(95)
		PaPetBG2:SetFrameStrata("LOW")
		PaPetBG2:SetFrameLevel(5)
		PPETBG3:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\ToT")		
		PPETBG3:SetVertexColor(1,1,1,1)	
		PPETBG3:SetAllPoints(PaPetBG2)
		PaPetBG2.texture = PPETBG3
		PaPetBG2:Show()	
	end
end
	-- ------------------------------------
	-- party target ("partytarget%d")
	-- ------------------------------------	
if usepartytargets == true then	
	if(unit and unit:find('party%dtarget')) then
	oUFTagHolder:SetParent(self)
	
	self:SetWidth(135)
	self:SetHeight(18)
	self.Health:SetWidth(135)
	self.Health:SetHeight(16)	
	self.Power:Hide() 
	self.Name:SetWidth(150)
	self.Name:SetPoint("BOTTOM", self.Health, "TOP", 0, 2)			
	
		local PaPetBG = CreateFrame("Frame", nil, self)
		local PPETBG1 = PaPetBG:CreateTexture(nil,"BACKGROUND")
		PaPetBG:SetPoint("CENTER", self, "CENTER", 0, 1)
		PaPetBG:SetWidth(308) 
		PaPetBG:SetHeight(95)
		PaPetBG:SetFrameStrata("BACKGROUND")
		PaPetBG:SetFrameLevel(1)
		PPETBG1:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\ToTBG")		
		PPETBG1:SetVertexColor(1,1,1,1)	
		PPETBG1:SetAllPoints(PaPetBG)
		PaPetBG.texture = PPETBG1
		PaPetBG:Show()	

		local PaPetBG2 = CreateFrame("Frame", nil, self)
		local PPETBG3 = PaPetBG2:CreateTexture(nil,"BACKGROUND")
		PaPetBG2:SetPoint("CENTER", self, "CENTER", 0, 1)
		PaPetBG2:SetWidth(308) 
		PaPetBG2:SetHeight(95)
		PaPetBG2:SetFrameStrata("LOW")
		PaPetBG2:SetFrameLevel(5)
		PPETBG3:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\ToT")		
		PPETBG3:SetVertexColor(1,1,1,1)	
		PPETBG3:SetAllPoints(PaPetBG2)
		PaPetBG2.texture = PPETBG3
		PaPetBG2:Show()		
	end
end	

	-- ------------------------------------
	-- raid 
	-- ------------------------------------
if useraid == true then	
	if(self:GetParent():GetName():match"oUF_Raid") then
	oUFTagHolder:SetParent(self)	

	self:SetWidth(104) 
	self:SetHeight(16)
	self.Health:SetHeight(16)
	self.Health:SetWidth(100)	  
	self.Power:Hide()
	self.Name:SetWidth(150)	
	self.Name:SetFont(fontN, fontSN-4, fontF)
	self.Name:SetPoint("TOPLEFT", self.Health, 2, 0)

	self.Health.PERvalue:ClearAllPoints()
	self.Health.PERvalue:SetFont(font, fontS-4, fontF)		
	self.Health.PERvalue:SetPoint("LEFT", self.Health, "LEFT", 2, 0)
		
	afkIcon:SetPoint("CENTER", self, "CENTER", 70, 0)	  
	afkIcon:SetWidth(18)
	afkIcon:SetHeight(18)

	self.DebuffHighlight:SetParent(oUFTagHolder)

	self.Health:SetStatusBarColor(0.84, 0.76, 0.53)
	self.ignoreBanzai = true
	self.Health.colorClass = false
	self.Health.colorReaction = false
	self.Health.colorDisconnected = false
	self.Health.colorTapping = false		

		self.Debuffs = CreateFrame("Frame", nil, self)
		self.Debuffs.size = 16
		self.Debuffs:SetHeight(self.Debuffs.size)
		self.Debuffs:SetWidth(self.Debuffs.size * 2)
		self.Debuffs:SetPoint("RIGHT", self, "RIGHT", 22, 0)
		self.Debuffs.initialAnchor = "RIGHT"
		self.Debuffs["growth-x"] = "RIGHT"
		self.Debuffs.num = 2
		self.Debuffs.spacing = 2
		
		-- Combat Feedback for raid, ignore everything, but heals, set different fontsize
		self.CombatFeedbackText:SetFont(fontN, fontSN-4, fontF)			
		self.CombatFeedbackText.ignoreImmune = true -- ignore 'immune' reports
		self.CombatFeedbackText.ignoreDamage = true -- ignore damage hits, blocks, misses, parries etc.
		self.CombatFeedbackText.ignoreEnergize = true -- ignore energize events
		self.CombatFeedbackText.ignoreOther = true  -- ignore everything else	 
	
		self.ReadyCheck = self.Health:CreateTexture(nil, 'OVERLAY')
		self.ReadyCheck:SetPoint('CENTER', self, 0, -10)
		self.ReadyCheck:SetHeight(20)
		self.ReadyCheck:SetWidth(20)		
	
		local RaidMBG = CreateFrame("Frame", nil, self)
		local RAMBG = RaidMBG:CreateTexture(nil,"BACKGROUND")
		RaidMBG:SetPoint("CENTER", self, "CENTER", 0, 0)
		RaidMBG:SetWidth(104) 
		RaidMBG:SetHeight(16)
		RaidMBG:SetFrameStrata("BACKGROUND")
		RaidMBG:SetFrameLevel(0)
		RAMBG:SetTexture(bartex)		
		RAMBG:SetVertexColor(0.2,0.2,0.2,1)	
		RAMBG:SetAllPoints(RaidMBG)
		RaidMBG.texture = RAMBG
		RaidMBG:Show()	

	local TopLeft = self:CreateTexture(nil, "OVERLAY")
	TopLeft:SetTexture(frameborder)
	TopLeft:SetTexCoord(0, 1/3, 0, 1/3)
	TopLeft:SetPoint("TOPLEFT", self, -4, 4)
	TopLeft:SetWidth(12) TopLeft:SetHeight(12)
	TopLeft:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)

	local TopRight = self:CreateTexture(nil, "OVERLAY")
	TopRight:SetTexture(frameborder)
	TopRight:SetTexCoord(2/3, 1, 0, 1/3)
	TopRight:SetPoint("TOPRIGHT", self, 4, 4)
	TopRight:SetWidth(12) TopRight:SetHeight(12)
	TopRight:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)

	local BottomLeft = self:CreateTexture(nil, "OVERLAY")
	BottomLeft:SetTexture(frameborder)
	BottomLeft:SetTexCoord(0, 1/3, 2/3, 1)
	BottomLeft:SetPoint("BOTTOMLEFT", self, -4, -4)
	BottomLeft:SetWidth(12) BottomLeft:SetHeight(12)
	BottomLeft:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)

	local BottomRight = self:CreateTexture(nil, "OVERLAY")
	BottomRight:SetTexture(frameborder)
	BottomRight:SetTexCoord(2/3, 1, 2/3, 1)
	BottomRight:SetPoint("BOTTOMRIGHT", self, 4, -4)
	BottomRight:SetWidth(12) BottomRight:SetHeight(12)
	BottomRight:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)

	local TopEdge = self:CreateTexture(nil, "OVERLAY")
	TopEdge:SetTexture(frameborder)
	TopEdge:SetTexCoord(1/3, 2/3, 0, 1/3)
	TopEdge:SetPoint("TOPLEFT", TopLeft, "TOPRIGHT")
	TopEdge:SetPoint("TOPRIGHT", TopRight, "TOPLEFT")
	TopEdge:SetHeight(12)
	TopEdge:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)
		
	local BottomEdge = self:CreateTexture(nil, "OVERLAY")
	BottomEdge:SetTexture(frameborder)
	BottomEdge:SetTexCoord(1/3, 2/3, 2/3, 1)
	BottomEdge:SetPoint("BOTTOMLEFT", BottomLeft, "BOTTOMRIGHT")
	BottomEdge:SetPoint("BOTTOMRIGHT", BottomRight, "BOTTOMLEFT")
	BottomEdge:SetHeight(12)
	BottomEdge:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)
		
	local LeftEdge = self:CreateTexture(nil, "OVERLAY")
	LeftEdge:SetTexture(frameborder)
	LeftEdge:SetTexCoord(0, 1/3, 1/3, 2/3)
	LeftEdge:SetPoint("TOPLEFT", TopLeft, "BOTTOMLEFT")
	LeftEdge:SetPoint("BOTTOMLEFT", BottomLeft, "TOPLEFT")
	LeftEdge:SetWidth(12)
	LeftEdge:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)
		
	local RightEdge = self:CreateTexture(nil, "OVERLAY")
	RightEdge:SetTexture(frameborder)
	RightEdge:SetTexCoord(2/3, 1, 1/3, 2/3)
	RightEdge:SetPoint("TOPRIGHT", TopRight, "BOTTOMRIGHT")
	RightEdge:SetPoint("BOTTOMRIGHT", BottomRight, "TOPRIGHT")
	RightEdge:SetWidth(12)
	RightEdge:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)
    end		
end
	
	-- swing the magic stick ....
	if unit=="player" or unit=="targettarget" or unit=="focus" or unit=="target" or unit=="pet" or (self:GetParent():GetName():match"oUF_Raid") then
		self:SetAttribute('initial-height', height) 
		self:SetAttribute('initial-width', width)
	elseif(self:GetParent():GetName():match"oUF_Party") then
		self:SetAttribute('initial-height', 18) 
		self:SetAttribute('initial-width', 200) 		
	else
		self:SetAttribute('initial-height', height) 
		self:SetAttribute('initial-width', width)
	end	

	self.PostUpdateHealth = updateHealth
	self.PostUpdatePower = updatePower
	self.PostCreateAuraIcon = auraIcon
	self.PostUpdateAuraIcon = auraUpdateIcon
	self.PostUpdateAura = auraUpdate
	return self   
end

-- ------------------------------------------------------------------------
-- spawning the frames
-- ------------------------------------------------------------------------
oUF:RegisterStyle("oUF_Aion", func)
oUF:SetActiveStyle("oUF_Aion")

local player = oUF:Spawn("player", "oUF_Player")
player:SetPoint("TOPLEFT", 144, -64)

local target = oUF:Spawn("target", "oUF_Target")
target:SetPoint("TOP", 0, -70) 

local pet = oUF:Spawn("pet", "oUF_Pet")
pet:SetPoint("TOPLEFT", player, "TOPRIGHT", 50, -44)

local tot = oUF:Spawn("targettarget", "oUF_TargetTarget")
tot:SetPoint("TOPLEFT", target, "TOPRIGHT", 50, -44)

local focus	= oUF:Spawn("focus", "oUF_Focus")
focus:SetPoint("TOPLEFT", target, "TOPRIGHT", 50, 44)

-- scale some frames
oUF_Player:SetScale(scalePlayer)
oUF_Pet:SetScale(scalePlayerPet)
oUF_Target:SetScale(scaleTarget)
oUF_TargetTarget:SetScale(scaleTarget)
oUF_Focus:SetScale(scaleTarget)


local party = oUF:Spawn("header", "oUF_Party")
party:SetManyAttributes("showParty", true, "yOffset", 90, "point", "BOTTOM")
party:SetPoint("BOTTOM", UIParent, "BOTTOM", -560, 400)
party:Show()
oUF_Party:SetScale(ScaleParty)

-- postion teh freakin' party targets we must
local ptpos = {}
ptpos[1] = oUF:Spawn("party1target", "oUF_Party1Target")
ptpos[1]:SetPoint("TOPLEFT", oUF_PartyUnitButton1, "TOPRIGHT", 40, -34)
ptpos[1]:SetScale(ScalePT)
ptpos[2] = oUF:Spawn("party2target", "oUF_Party2Target")
ptpos[2]:SetPoint("TOPLEFT", oUF_PartyUnitButton2, "TOPRIGHT", 40, -34)
ptpos[2]:SetScale(ScalePT)
ptpos[3] = oUF:Spawn("party3target", "oUF_Party3Target")
ptpos[3]:SetPoint("TOPLEFT", oUF_PartyUnitButton3, "TOPRIGHT", 40, -34)
ptpos[3]:SetScale(ScalePT)
ptpos[4] = oUF:Spawn("party4target", "oUF_Party4Target")
ptpos[4]:SetPoint("TOPLEFT", oUF_PartyUnitButton4, "TOPRIGHT", 40, -34)
ptpos[4]:SetScale(ScalePT)

-- party pet
local pppos = {}
pppos[1] = oUF:Spawn("partypet1", "oUF_PartyPet1")
pppos[1]:SetPoint("TOPLEFT", oUF_PartyUnitButton1, "TOPRIGHT", 40, 34)
pppos[1]:SetScale(ScalePP)
pppos[2] = oUF:Spawn("partypet2", "oUF_PartyPet2")
pppos[2]:SetPoint("TOPLEFT", oUF_PartyUnitButton2, "TOPRIGHT", 40, 34)
pppos[2]:SetScale(ScalePP)
pppos[3] = oUF:Spawn("partypet3", "oUF_PartyPet3")
pppos[3]:SetPoint("TOPLEFT", oUF_PartyUnitButton3, "TOPRIGHT", 40, 34)
pppos[3]:SetScale(ScalePP)
pppos[4] = oUF:Spawn("partypet4", "oUF_PartyPet4")
pppos[4]:SetPoint("TOPLEFT", oUF_PartyUnitButton4, "TOPRIGHT", 40, 34)
pppos[4]:SetScale(ScalePP)

-- raid groups 1-4
local raid = {}
for i = 1, 4 do
	local raidgroup = oUF:Spawn('header', 'oUF_Raid'..i)
	raidgroup:SetManyAttributes('groupFilter', tostring(i), 'showRaid', true, 'yOffSet', -10, "point", "TOP")
	table.insert(raid, raidgroup)
	if(i==1) then
		raidgroup:SetPoint('TOPLEFT', UIParent, 20, -136)
	else
		raidgroup:SetPoint('TOP', raid[i-1], 'BOTTOM', 0, -10)
	end
end

-- raid groups 5-8
local raid2 = {}
for i = 5, 8 do
	local raidgroup = oUF:Spawn('header', 'oUF_Raid'..i)
	raidgroup:SetManyAttributes('groupFilter', tostring(i), 'showRaid', true, 'yOffSet', -10, "point", "TOP")
	table.insert(raid, raidgroup)
	if(i==5) then
		raidgroup:SetPoint('TOPLEFT', UIParent, 170, -136)
	else
		raidgroup:SetPoint('TOP', raid[i-1], 'BOTTOM', 0, -10)
	end
end	


-- party toggle in raid
local partyToggle = CreateFrame('Frame')
partyToggle:RegisterEvent('PLAYER_LOGIN')
partyToggle:RegisterEvent('RAID_ROSTER_UPDATE')
partyToggle:RegisterEvent('PARTY_LEADER_CHANGED')
partyToggle:RegisterEvent('PARTY_MEMBERS_CHANGED')
partyToggle:SetScript('OnEvent', function(self)
	if(InCombatLockdown()) then
		self:RegisterEvent('PLAYER_REGEN_ENABLED')
	else
		self:UnregisterEvent('PLAYER_REGEN_ENABLED')
		if(GetNumRaidMembers() > 5) then
			party:Hide()
			for i,v in ipairs(raid) do v:Show() end
			ptpos[1]:Disable()
			ptpos[2]:Disable()
			ptpos[3]:Disable()
			ptpos[4]:Disable()
			pppos[1]:Disable()
			pppos[2]:Disable()
			pppos[3]:Disable()
			pppos[4]:Disable()
		else
			party:Show()
			for i,v in ipairs(raid) do v:Hide() end
			ptpos[1]:Enable()
			ptpos[2]:Enable()
			ptpos[3]:Enable()
			ptpos[4]:Enable()
			pppos[1]:Enable()
			pppos[2]:Enable()
			pppos[3]:Enable()
			pppos[4]:Enable()			
		end
	end
end)

-- ------------------------------------------------------------------------
-- background frames
-- ------------------------------------------------------------------------
if useAionPanel == true then
	local bottompanel = CreateFrame("Frame", nil)
	local BoPan = bottompanel:CreateTexture(nil,"BACKGROUND")
		bottompanel:SetPoint('BOTTOM',UIParent, 0, 0)
		bottompanel:SetWidth(2048)
		bottompanel:SetHeight(128)
		bottompanel:SetFrameStrata("BACKGROUND")
		bottompanel:SetFrameLevel(4)
		BoPan:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\PanelV2.tga")		
		BoPan:SetVertexColor(1,1,1,1)	
		BoPan:SetAllPoints(bottompanel)
		bottompanel.texture = BoPan
		bottompanel:Show()	
		bottompanel:SetScale(0.7)
end		

if useviewport == true then
	local bottompan = CreateFrame("Frame",nil,UIParent)
	bottompan:SetFrameStrata("BACKGROUND")
	bottompan:SetFrameLevel(4)	
	bottompan:SetWidth(1370)
	bottompan:SetHeight(78)
	bottompan:SetPoint("BOTTOMLEFT", 0, 0)
	bottompan:Show()
	bottompan:SetScale(1)
	local bottompan2 = bottompan:CreateTexture(nil,"BACKGROUND")
	bottompan2:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\bottompanel.tga")
	bottompan2:SetAllPoints(bottompan)	
	bottompan2:SetVertexColor(1,1,1)
	bottompan2:SetVertexColor(maincolor[1],maincolor[2],maincolor[3])
	--bottompan2:SetVertexColor(sndcolor[1], sndcolor[2], sndcolor[3]) 	
	bottompan2:SetAlpha(1)

	bottompan.overlay = bottompan:CreateTexture(nil, "OVERLAY");
	bottompan.overlay:SetTexture("Interface\\AddOns\\oUF_Aion\\media\\dQ.tga");
	bottompan.overlay:SetWidth(1370)
	bottompan.overlay:SetHeight(1)	
	bottompan.overlay:SetPoint("BOTTOMLEFT", 0, 22)	
	--bottompan.overlay:SetVertexColor(maincolor[1],maincolor[2],maincolor[3]);
	bottompan.overlay:SetVertexColor(sndcolor[1], sndcolor[2], sndcolor[3]);
	
	local toppan = CreateFrame("Frame",nil,UIParent)
	toppan:SetFrameStrata("BACKGROUND")
	toppan:SetFrameLevel(3)		
	toppan:SetWidth(1370)
	toppan:SetHeight(78)
	toppan:SetPoint("TOPLEFT", 0, 0)
	toppan:Show()
	toppan:SetScale(1)
	local toppan2 = toppan:CreateTexture(nil,"BACKGROUND")
	toppan2:SetTexture("Interface\\AddOns\\oUF_Aion\\Art\\toppanel.tga")
	toppan2:SetAllPoints(toppan)	
	toppan2:SetVertexColor(maincolor[1],maincolor[2],maincolor[3])
	--toppan2:SetVertexColor(sndcolor[1], sndcolor[2], sndcolor[3]) 	
	toppan2:SetAlpha(1)	
	
	toppan.overlay = toppan:CreateTexture(nil, "OVERLAY");
	toppan.overlay:SetTexture("Interface\\AddOns\\oUF_Aion\\media\\dQ.tga");
	toppan.overlay:SetWidth(1370)
	toppan.overlay:SetHeight(1)	
	toppan.overlay:SetPoint("TOPLEFT", 0, -22)	
	--toppan.overlay:SetVertexColor(maincolor[1],maincolor[2],maincolor[3]);
	toppan.overlay:SetVertexColor(sndcolor[1], sndcolor[2], sndcolor[3]);

-- modify the worldframe (create a viewport)
local top = 23
local bottom = 23
local left = 0
local right = 0
local currentYResolution = 1050

local scaling = 768 / 1050
	
ViewportOverlay = WorldFrame:CreateTexture(nil, "BACKGROUND")
ViewportOverlay:SetTexture(0, 0, 0, 1)
ViewportOverlay:SetPoint("TOPLEFT", UIParent, "TOPLEFT", -1, 1)
ViewportOverlay:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 1, -1)

WorldFrame:SetPoint("TOPLEFT", (left * scaling), -(top * scaling))
WorldFrame:SetPoint("BOTTOMRIGHT", -(right * scaling), (bottom * scaling))
WorldFrame:SetPoint("TOPLEFT", 0, -(top * 0.75))
WorldFrame:SetPoint("BOTTOMRIGHT", 0, (bottom * 0.75))
end